/**
 * SPDX-License-Identifier: MIT
 * Find the full license text at: https://gitlab.com/1of0/cpp/iptmerge/-/blob/master/LICENSE.md
 */

#include <cxxopts.hpp>
#include <filesystem>
#include <fmt/format.h>
#include <iostream>
#include <yaml-cpp/yaml.h>

#include "../src/compile_time.h"
#include "../src/merge.h"
#include "../src/netfilter.h"
#include "../src/software_licenses.h"

using namespace fmt;
using namespace iptmerge;
using namespace iptmerge::merge;
using namespace iptmerge::merge::configuration;
using namespace iptmerge::netfilter;
using namespace iptmerge::netfilter::structure;

int main(int argc, char** argv)
{
    using namespace std;

    string mergeBehaviourFile, generatedStateFile, runningStateFile;

    cxxopts::Options options(
        "iptmerge",
        "Merges two iptables-save formatted dumps, and outputs a dump that can be restored with `iptables-restore --noflush`"
    );
    options
        .positional_help("<generated-state> [<running-state>]")
        .show_positional_help()
        .add_options()
            (
                "m,merge-behaviour",
                "File containing a YAML document with settings for the generator.",
                cxxopts::value<string>(mergeBehaviourFile)
            )
            (
                "g,generated-state",
                "File containing an iptables-save formatted configuration that will be used as master template for the restore file.",
                cxxopts::value<string>(generatedStateFile)
            )
            (
                "r,running-state",
                "File containing an the running iptables configuration as generated by iptables-save. If not provided the running state should be provided through STDIN.",
                cxxopts::value<string>(runningStateFile)
            )
            (
                "l,licenses",
                "Print licenses of software and used libraries"
            )
            (
                "h,help",
                "Print usage"
            );

    options.parse_positional({"generated-state", "running-state"});

    cxxopts::ParseResult result = options.parse(argc, argv);

    if (result.count("licenses")) {
        printSoftwareLicenses();
        exit(0);
    }

    if (result.count("help") || generatedStateFile.empty()) {
        cout << options.help() << endl;
        exit(0);
    }

    if (!mergeBehaviourFile.empty() && !filesystem::exists(mergeBehaviourFile)) {
        cerr << format("File '{}' does not exist\n", mergeBehaviourFile);
        exit(3);
    }

    if (!filesystem::exists(generatedStateFile)) {
        cerr << format("File '{}' does not exist\n", generatedStateFile);
        exit(3);
    }

    if (!runningStateFile.empty() && !filesystem::exists(runningStateFile)) {
        cerr << format("File '{}' does not exist\n", runningStateFile);
        exit(3);
    }

    try {
        auto mergeBehaviour = mergeBehaviourFile.empty()
            ? MergeBehaviour{}
            : YAML::LoadFile(mergeBehaviourFile).as<MergeBehaviour>();

        State generatedState = StateParser::parseFile(generatedStateFile);
        State runningState = runningStateFile.empty()
                             ? StateParser::parseStream(cin)
                             : StateParser::parseFile(runningStateFile);

        State merged = StateMerger::merge(runningState, generatedState, mergeBehaviour);

        cout << merged.toString();
    } catch (YAML::Exception& e) {
        if (e.mark.is_null()) {
            cerr << e.msg << endl;
        } else {
            cerr << format(
                "Error in file '{}' on line {}, column {}: {}\n",
                mergeBehaviourFile,
                e.mark.line + 1,
                e.mark.column + 1,
                e.msg
            );
        }
        exit(4);
    } catch (IptmergeException& e) {
        cerr << format("Error: {}\n", e.what());
        exit(5);
    }

    return 0;
}
